/**
 * Generated by Apache Royale Compiler from org/apache/royale/file/beads/FileLoaderAndUploader.as
 * org.apache.royale.file.beads.FileLoaderAndUploader
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.file.beads.FileLoaderAndUploader');

goog.require('org.apache.royale.file.FileProxy');
goog.require('org.apache.royale.file.beads.FileLoader');
goog.require('org.apache.royale.file.beads.FileModel');
goog.require('org.apache.royale.file.beads.FileUploader');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.file.beads.FileLoaderAndUploader = function() {
  ;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.file.beads.FileLoaderAndUploader', org.apache.royale.file.beads.FileLoaderAndUploader);


/**
 * @private
 * @type {org.apache.royale.file.beads.FileLoader}
 */
org.apache.royale.file.beads.FileLoaderAndUploader.prototype._loader;


/**
 * @private
 * @type {org.apache.royale.file.beads.FileUploader}
 */
org.apache.royale.file.beads.FileLoaderAndUploader.prototype._uploader;


/**
 * @private
 * @type {string}
 */
org.apache.royale.file.beads.FileLoaderAndUploader.prototype._url;


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.file.beads.FileLoaderAndUploader.prototype._strand;


/**
 *  Upload a file to the specified url. If file hasn't been loaded already it will be.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9
 * @export
 * @param {string} url
 */
org.apache.royale.file.beads.FileLoaderAndUploader.prototype.upload = function(url) {
  var /** @type {org.apache.royale.file.beads.FileModel} */ fileModel = org.apache.royale.utils.Language.as(org.apache.royale.utils.Language.as(this._strand, org.apache.royale.file.FileProxy).model, org.apache.royale.file.beads.FileModel);
  if (!fileModel.blob) {
    this._url = url;
    org.apache.royale.utils.Language.as(this._strand, org.apache.royale.file.FileProxy).model.addEventListener("blobChanged", org.apache.royale.utils.Language.closure(this.blobChangedHandler, this, 'blobChangedHandler'));
    this._loader.load();
  } else {
    this._uploader.upload(url);
  }
};


/**
 * @asprivate
 * @private
 * @param {org.apache.royale.events.Event} e
 */
org.apache.royale.file.beads.FileLoaderAndUploader.prototype.blobChangedHandler = function(e) {
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.file.FileProxy).model.removeEventListener('blobChanged', org.apache.royale.utils.Language.closure(this.blobChangedHandler, this, 'blobChangedHandler'));
  this._uploader.upload(this._url);
};


org.apache.royale.file.beads.FileLoaderAndUploader.prototype.set__strand = function(value) {
  this._strand = value;
  this._loader = org.apache.royale.utils.Language.as(value.getBeadByType(org.apache.royale.file.beads.FileLoader), org.apache.royale.file.beads.FileLoader);
  if (!this._loader) {
    this._loader = new org.apache.royale.file.beads.FileLoader();
    value.addBead(this._loader);
  }
  this._uploader = org.apache.royale.utils.Language.as(value.getBeadByType(org.apache.royale.file.beads.FileUploader), org.apache.royale.file.beads.FileUploader);
  if (!this._uploader) {
    this._uploader = new org.apache.royale.file.beads.FileUploader();
    value.addBead(this._uploader);
  }
};


Object.defineProperties(org.apache.royale.file.beads.FileLoaderAndUploader.prototype, /** @lends {org.apache.royale.file.beads.FileLoaderAndUploader.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.file.beads.FileLoaderAndUploader.prototype.set__strand}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.file.beads.FileLoaderAndUploader.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'FileLoaderAndUploader', qName: 'org.apache.royale.file.beads.FileLoaderAndUploader', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.file.beads.FileLoaderAndUploader.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.file.beads.FileLoaderAndUploader'}
      };
    },
    methods: function () {
      return {
        'FileLoaderAndUploader': { type: '', declaredBy: 'org.apache.royale.file.beads.FileLoaderAndUploader'},
        'upload': { type: 'void', declaredBy: 'org.apache.royale.file.beads.FileLoaderAndUploader', parameters: function () { return [  { index: 1, type: 'String', optional: false } ]; }}
      };
    }
  };
};