/**
 * Generated by Apache Royale Compiler from org/apache/royale/file/beads/FileUploader.as
 * org.apache.royale.file.beads.FileUploader
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.file.beads.FileUploader');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.file.FileProxy');
goog.require('org.apache.royale.file.beads.FileModel');
goog.require('org.apache.royale.net.URLBinaryLoader');
goog.require('org.apache.royale.net.URLRequest');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.file.beads.FileUploader = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.file.beads.FileUploader', org.apache.royale.file.beads.FileUploader);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.file.beads.FileUploader.prototype._strand;


/**
 *  Upload a file to the specified url.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9
 * @export
 * @param {string} url
 */
org.apache.royale.file.beads.FileUploader.prototype.upload = function(url) {
  var /** @type {org.apache.royale.net.URLBinaryLoader} */ binaryUploader = new org.apache.royale.net.URLBinaryLoader();
  var /** @type {org.apache.royale.net.URLRequest} */ req = new org.apache.royale.net.URLRequest();
  req.method = "POST";
  req.data = org.apache.royale.utils.Language.as(this.host.model, org.apache.royale.file.beads.FileModel).blob;
  req.url = url;
  binaryUploader.addEventListener(org.apache.royale.events.Event.COMPLETE, org.apache.royale.utils.Language.closure(this.completeHandler, this, 'completeHandler'));
  binaryUploader.load(req);
};


/**
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.file.beads.FileUploader.prototype.completeHandler = function(event) {
  org.apache.royale.utils.Language.as(event.target, org.apache.royale.events.IEventDispatcher).removeEventListener(org.apache.royale.events.Event.COMPLETE, org.apache.royale.utils.Language.closure(this.completeHandler, this, 'completeHandler'));
  org.apache.royale.utils.Language.as(this.host, org.apache.royale.events.IEventDispatcher).dispatchEvent(event);
};


org.apache.royale.file.beads.FileUploader.prototype.set__strand = function(value) {
  this._strand = value;
};


org.apache.royale.file.beads.FileUploader.prototype.get__host = function() {
  return org.apache.royale.utils.Language.as(this._strand, org.apache.royale.file.FileProxy);
};


Object.defineProperties(org.apache.royale.file.beads.FileUploader.prototype, /** @lends {org.apache.royale.file.beads.FileUploader.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.file.beads.FileUploader.prototype.set__strand},
/**
  * @export
  * @type {org.apache.royale.file.FileProxy} */
host: {
get: org.apache.royale.file.beads.FileUploader.prototype.get__host}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.file.beads.FileUploader.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'FileUploader', qName: 'org.apache.royale.file.beads.FileUploader', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.file.beads.FileUploader.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.file.beads.FileUploader'}
      };
    },
    methods: function () {
      return {
        'upload': { type: 'void', declaredBy: 'org.apache.royale.file.beads.FileUploader', parameters: function () { return [  { index: 1, type: 'String', optional: false } ]; }}
      };
    },
    metadata: function () { return [  ]; }
  };
};