/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/BinaryUploader.as
 * org.apache.royale.net.BinaryUploader
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.BinaryUploader');

goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.net.HTTPConstants');
goog.require('org.apache.royale.net.HTTPHeader');
goog.require('org.apache.royale.net.HTTPServiceBase');
goog.require('org.apache.royale.utils.Language');



/**
 *  @royaleignorecoercion org.apache.royale.core.WrappedHTMLElement
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @constructor
 * @extends {org.apache.royale.net.HTTPServiceBase}
 * @implements {org.apache.royale.core.IStrand}
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.net.BinaryUploader = function() {
  
  this._method = org.apache.royale.net.HTTPConstants.POST;
  org.apache.royale.net.BinaryUploader.base(this, 'constructor');
  this.element = new XMLHttpRequest();
};
goog.inherits(org.apache.royale.net.BinaryUploader, org.apache.royale.net.HTTPServiceBase);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.net.BinaryUploader', org.apache.royale.net.BinaryUploader);


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.BinaryUploader.prototype._contentType = "application/octet-stream";


/**
 * @private
 * @type {org.apache.royale.utils.BinaryData}
 */
org.apache.royale.net.BinaryUploader.prototype._binaryData;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.net.BinaryUploader.prototype._headers;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.BinaryUploader.prototype._method;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.net.BinaryUploader.prototype._responseHeaders;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.BinaryUploader.prototype._responseURL;


/**
 * @private
 * @type {number}
 */
org.apache.royale.net.BinaryUploader.prototype._status = 0;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.BinaryUploader.prototype._url;


/**
 * @private
 * @type {number}
 */
org.apache.royale.net.BinaryUploader.prototype._timeout = 0;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.BinaryUploader.prototype._id;


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.net.BinaryUploader.prototype._strand;


/**
 * @export
 * @type {Array}
 */
org.apache.royale.net.BinaryUploader.prototype.beads;


/**
 *  Starts the upload to the server.  Events
 *  are dispatched as the upload progresses.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @export
 */
org.apache.royale.net.BinaryUploader.prototype.send = function() {
  
  var /** @type {XMLHttpRequest} */ element = org.apache.royale.utils.Language.as(this.element, XMLHttpRequest);
  element.onreadystatechange = org.apache.royale.utils.Language.closure(this.progressHandler, this, 'progressHandler');
  this.url = this._url;
  var /** @type {string} */ binaryData = null;
  if (this._binaryData != null) {
    if (this._method == org.apache.royale.net.HTTPConstants.GET) {
      if (this.url.indexOf('?') != -1) {
        this.url += org.apache.royale.utils.Language.string(this._binaryData.data);
      } else {
        this.url += '?' + this._binaryData.data;
      }
    } else {
      binaryData = this._binaryData.data.toString();
    }
  }
  element.open(this._method, this._url, true);
  element.timeout = this._timeout;
  var /** @type {boolean} */ sawContentType = false;
  if (this._headers) {
    var /** @type {number} */ n = this._headers.length;
    for (var /** @type {number} */ i = 0; i < n; i++) {
      var /** @type {org.apache.royale.net.HTTPHeader} */ header = this._headers[i];
      if (header.name == org.apache.royale.net.HTTPHeader.CONTENT_TYPE) {
        sawContentType = true;
      }
      element.setRequestHeader(header.name, header.value);
    }
  }
  if (this._method != org.apache.royale.net.HTTPConstants.GET && !sawContentType && binaryData) {
    element.setRequestHeader(org.apache.royale.net.HTTPHeader.CONTENT_TYPE, this._contentType);
  }
  if (binaryData) {
    element.setRequestHeader(org.apache.royale.net.HTTPHeader.CONTENT_LENGTH, binaryData.length.toString());
    element.setRequestHeader(org.apache.royale.net.HTTPHeader.CONNECTION, 'close');
    element.send(binaryData);
  } else {
    element.send();
  }
};


/**
 * @royaleignorecoercion XMLHttpRequest
 * @protected
 */
org.apache.royale.net.BinaryUploader.prototype.progressHandler = function() {
  var /** @type {XMLHttpRequest} */ element = this.element;
  if (element.readyState == 2) {
    this._status = element.status;
    this.dispatchEvent(org.apache.royale.net.HTTPConstants.RESPONSE_STATUS);
    this.dispatchEvent(org.apache.royale.net.HTTPConstants.STATUS);
  } else if (element.readyState == 4) {
    this.dispatchEvent(org.apache.royale.net.HTTPConstants.COMPLETE);
  }
};


org.apache.royale.net.BinaryUploader.prototype.get__contentType = function() {
  return this._contentType;
};


org.apache.royale.net.BinaryUploader.prototype.set__contentType = function(value) {
  if (this._contentType != value) {
    this._contentType = value;
    this.dispatchEvent(new org.apache.royale.events.Event("contentTypeChanged"));
  }
};


org.apache.royale.net.BinaryUploader.prototype.get__binaryData = function() {
  return this._binaryData;
};


org.apache.royale.net.BinaryUploader.prototype.set__binaryData = function(value) {
  if (this._binaryData != value) {
    this._binaryData = value;
    this.dispatchEvent(new org.apache.royale.events.Event("binaryDataChanged"));
  }
};


org.apache.royale.net.BinaryUploader.prototype.get__headers = function() {
  if (this._headers == null)
    this._headers = [];
  return this._headers;
};


org.apache.royale.net.BinaryUploader.prototype.set__headers = function(value) {
  if (this._headers != value) {
    this._headers = value;
    this.dispatchEvent(new org.apache.royale.events.Event("headersChanged"));
  }
};


org.apache.royale.net.BinaryUploader.prototype.get__method = function() {
  return this._method;
};


org.apache.royale.net.BinaryUploader.prototype.set__method = function(value) {
  if (this._method != value) {
    this._method = value;
    this.dispatchEvent(new org.apache.royale.events.Event("methodChanged"));
  }
};


org.apache.royale.net.BinaryUploader.prototype.get__responseHeaders = function() {
  
  var /** @type {string} */ allHeaders;
  var /** @type {number} */ c = 0;
  var /** @type {string} */ hdr;
  var /** @type {number} */ i = 0;
  var /** @type {number} */ n = 0;
  var /** @type {string} */ part1;
  var /** @type {string} */ part2;
  var /** @type {XMLHttpRequest} */ element = org.apache.royale.utils.Language.as(this.element, XMLHttpRequest);
  if (!this._responseHeaders) {
    allHeaders = element.getAllResponseHeaders();
    this._responseHeaders = allHeaders.split('\n');
    n = this._responseHeaders.length;
    for (i = 0; i < n; i++) {
      hdr = org.apache.royale.utils.Language.string(this._responseHeaders[i]);
      c = hdr.indexOf(':');
      part1 = hdr.substring(0, c);
      part2 = hdr.substring(c + 2);
      this._responseHeaders[i] = new org.apache.royale.net.HTTPHeader(part1, part2);
    }
  }
  return this._responseHeaders;
};


org.apache.royale.net.BinaryUploader.prototype.get__responseURL = function() {
  return this._responseURL;
};


org.apache.royale.net.BinaryUploader.prototype.get__status = function() {
  return this._status;
};


org.apache.royale.net.BinaryUploader.prototype.get__url = function() {
  return this._url;
};


org.apache.royale.net.BinaryUploader.prototype.set__url = function(value) {
  if (this._url != value) {
    this._url = value;
    this.dispatchEvent(new org.apache.royale.events.Event("urlChanged"));
  }
};


org.apache.royale.net.BinaryUploader.prototype.get__timeout = function() {
  return this._timeout;
};


org.apache.royale.net.BinaryUploader.prototype.set__timeout = function(value) {
  if (this._timeout != value) {
    this._timeout = value;
    this.dispatchEvent(new org.apache.royale.events.Event("timeoutChanged"));
  }
};


org.apache.royale.net.BinaryUploader.prototype.get__id = function() {
  return this._id;
};


org.apache.royale.net.BinaryUploader.prototype.set__id = function(value) {
  if (this._id != value) {
    this._id = value;
    this.dispatchEvent(new org.apache.royale.events.Event("idChanged"));
  }
};


org.apache.royale.net.BinaryUploader.prototype.set__strand = function(value) {
  this._strand = value;
  var foreachiter0_target = this.beads;
  for (var foreachiter0 in foreachiter0_target) 
  {
  var bead = foreachiter0_target[foreachiter0];
  
    this.addBead(bead);}
  
  this.dispatchEvent(new org.apache.royale.events.Event("beadsAdded"));
};


org.apache.royale.net.BinaryUploader.prototype.get__data = function() {
  
  return this.element.responseText;
};


Object.defineProperties(org.apache.royale.net.BinaryUploader.prototype, /** @lends {org.apache.royale.net.BinaryUploader.prototype} */ {
/**
  * @export
  * @type {string} */
contentType: {
get: org.apache.royale.net.BinaryUploader.prototype.get__contentType,
set: org.apache.royale.net.BinaryUploader.prototype.set__contentType},
/**
  * @export
  * @type {org.apache.royale.utils.BinaryData} */
binaryData: {
get: org.apache.royale.net.BinaryUploader.prototype.get__binaryData,
set: org.apache.royale.net.BinaryUploader.prototype.set__binaryData},
/**
  * @export
  * @type {Array} */
headers: {
get: org.apache.royale.net.BinaryUploader.prototype.get__headers,
set: org.apache.royale.net.BinaryUploader.prototype.set__headers},
/**
  * @export
  * @type {string} */
method: {
get: org.apache.royale.net.BinaryUploader.prototype.get__method,
set: org.apache.royale.net.BinaryUploader.prototype.set__method},
/**
  * @export
  * @type {Array} */
responseHeaders: {
get: org.apache.royale.net.BinaryUploader.prototype.get__responseHeaders},
/**
  * @export
  * @type {string} */
responseURL: {
get: org.apache.royale.net.BinaryUploader.prototype.get__responseURL},
/**
  * @export
  * @type {number} */
status: {
get: org.apache.royale.net.BinaryUploader.prototype.get__status},
/**
  * @export
  * @type {string} */
url: {
get: org.apache.royale.net.BinaryUploader.prototype.get__url,
set: org.apache.royale.net.BinaryUploader.prototype.set__url},
/**
  * @export
  * @type {number} */
timeout: {
get: org.apache.royale.net.BinaryUploader.prototype.get__timeout,
set: org.apache.royale.net.BinaryUploader.prototype.set__timeout},
/**
  * @export
  * @type {string} */
id: {
get: org.apache.royale.net.BinaryUploader.prototype.get__id,
set: org.apache.royale.net.BinaryUploader.prototype.set__id},
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.net.BinaryUploader.prototype.set__strand},
/**
  * @export
  * @type {*} */
data: {
get: org.apache.royale.net.BinaryUploader.prototype.get__data}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.BinaryUploader.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'BinaryUploader', qName: 'org.apache.royale.net.BinaryUploader', kind: 'class' }], interfaces: [org.apache.royale.core.IStrand, org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.BinaryUploader.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'beads': { type: 'Array'}
      };
    },
    accessors: function () {
      return {
        'contentType': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'binaryData': { type: 'org.apache.royale.utils.BinaryData', access: 'readwrite', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'headers': { type: 'Array', access: 'readwrite', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'method': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'responseHeaders': { type: 'Array', access: 'readonly', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'responseURL': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'status': { type: 'int', access: 'readonly', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'url': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'timeout': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'id': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'data': { type: '*', access: 'readonly', declaredBy: 'org.apache.royale.net.BinaryUploader'}
      };
    },
    methods: function () {
      return {
        'BinaryUploader': { type: '', declaredBy: 'org.apache.royale.net.BinaryUploader'},
        'send': { type: 'void', declaredBy: 'org.apache.royale.net.BinaryUploader'}
      };
    },
    metadata: function () { return [  ]; }
  };
};