/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/HTTPService.as
 * org.apache.royale.net.HTTPService
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.HTTPService');

goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.debugging.assert');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.net.HTTPConstants');
goog.require('org.apache.royale.net.HTTPHeader');
goog.require('org.apache.royale.net.HTTPServiceBase');
goog.require('org.apache.royale.utils.Language');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 *  @royaleignorecoercion org.apache.royale.core.WrappedHTMLElement
 * @constructor
 * @extends {org.apache.royale.net.HTTPServiceBase}
 * @implements {org.apache.royale.core.IStrand}
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.net.HTTPService = function() {
  
  this._contentType = org.apache.royale.net.HTTPConstants.FORM_URL_ENCODED;
  this._method = org.apache.royale.net.HTTPConstants.GET;
  org.apache.royale.net.HTTPService.base(this, 'constructor');
  this.element = new XMLHttpRequest();
};
goog.inherits(org.apache.royale.net.HTTPService, org.apache.royale.net.HTTPServiceBase);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.net.HTTPService', org.apache.royale.net.HTTPService);


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.HTTPService.prototype._contentType;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.HTTPService.prototype._contentData;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.net.HTTPService.prototype._headers;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.HTTPService.prototype._method;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.net.HTTPService.prototype._responseHeaders;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.HTTPService.prototype._responseURL;


/**
 * @private
 * @type {number}
 */
org.apache.royale.net.HTTPService.prototype._status = 0;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.HTTPService.prototype._url;


/**
 * @private
 * @type {number}
 */
org.apache.royale.net.HTTPService.prototype._timeout = 0;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.HTTPService.prototype._id;


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.net.HTTPService.prototype._strand;


/**
 * @export
 * @type {Array}
 */
org.apache.royale.net.HTTPService.prototype.beads;


/**
 *  Sends the headers and contentData to the server.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 *  @royaleignorecoercion XMLHttpRequest
 * @export
 */
org.apache.royale.net.HTTPService.prototype.send = function() {
  if (this._beads == null) {
    var foreachiter0_target = this.beads;
    for (var foreachiter0 in foreachiter0_target) 
    {
    var bead = foreachiter0_target[foreachiter0];
    
      this.addBead(bead);}
    
  }
  this.dispatchEvent(new org.apache.royale.events.Event("preSend"));
  
  var /** @type {XMLHttpRequest} */ element = this.element;
  element.onreadystatechange = org.apache.royale.utils.Language.closure(this.progressHandler, this, 'progressHandler');
  this.url = this._url;
  var /** @type {string} */ contentData = null;
  if (this._contentData != null) {
    if (this._method == org.apache.royale.net.HTTPConstants.GET) {
      if (this.url.indexOf('?') != -1) {
        this.url += this._contentData;
      } else {
        this.url += '?' + this._contentData;
      }
    } else {
      contentData = this._contentData;
    }
  }
  element.open(this._method, this._url, true);
  element.timeout = this._timeout;
  var /** @type {boolean} */ sawContentType = false;
  if (this._headers) {
    var /** @type {number} */ n = this._headers.length;
    for (var /** @type {number} */ i = 0; i < n; i++) {
      var /** @type {org.apache.royale.net.HTTPHeader} */ header = this._headers[i];
      if (header.name == org.apache.royale.net.HTTPHeader.CONTENT_TYPE) {
        sawContentType = true;
      }
      element.setRequestHeader(header.name, header.value);
    }
  }
  if (this._method != org.apache.royale.net.HTTPConstants.GET && !sawContentType && contentData) {
    element.setRequestHeader(org.apache.royale.net.HTTPHeader.CONTENT_TYPE, this._contentType);
  }
  if (contentData) {
    element.send(contentData);
  } else {
    element.send();
  }
  this.dispatchEvent(new org.apache.royale.events.Event("postSend"));
};


/**
 * @royaleignorecoercion XMLHttpRequest
 * @protected
 */
org.apache.royale.net.HTTPService.prototype.progressHandler = function() {
  var /** @type {XMLHttpRequest} */ element = this.element;
  if (element.readyState == 2) {
    this._status = element.status;
    this.dispatchEvent(org.apache.royale.net.HTTPConstants.RESPONSE_STATUS);
    this.dispatchEvent(org.apache.royale.net.HTTPConstants.STATUS);
  } else if (element.readyState == 4) {
    this.dispatchEvent(org.apache.royale.net.HTTPConstants.COMPLETE);
  }
};


/**
 * @private
 * @type {Object}
 */
org.apache.royale.net.HTTPService.prototype._json;


org.apache.royale.net.HTTPService.prototype.get__contentType = function() {
  return this._contentType;
};


org.apache.royale.net.HTTPService.prototype.set__contentType = function(value) {
  if (this._contentType != value) {
    this._contentType = value;
    this.dispatchEvent(new org.apache.royale.events.Event("contentTypeChanged"));
  }
};


org.apache.royale.net.HTTPService.prototype.get__contentData = function() {
  return this._contentData;
};


org.apache.royale.net.HTTPService.prototype.set__contentData = function(value) {
  if (this._contentData != value) {
    this._contentData = value;
    this.dispatchEvent(new org.apache.royale.events.Event("contentDataChanged"));
  }
};


org.apache.royale.net.HTTPService.prototype.get__headers = function() {
  if (this._headers == null)
    this._headers = [];
  return this._headers;
};


org.apache.royale.net.HTTPService.prototype.set__headers = function(value) {
  if (this._headers != value) {
    this._headers = value;
    this.dispatchEvent(new org.apache.royale.events.Event("headersChanged"));
  }
};


org.apache.royale.net.HTTPService.prototype.get__method = function() {
  return this._method;
};


org.apache.royale.net.HTTPService.prototype.set__method = function(value) {
  if (this._method != value) {
    this._method = value;
    this.dispatchEvent(new org.apache.royale.events.Event("methodChanged"));
  }
};


org.apache.royale.net.HTTPService.prototype.get__responseHeaders = function() {
  
  var /** @type {string} */ allHeaders;
  var /** @type {number} */ c = 0;
  var /** @type {string} */ hdr;
  var /** @type {number} */ i = 0;
  var /** @type {number} */ n = 0;
  var /** @type {string} */ part1;
  var /** @type {string} */ part2;
  var /** @type {XMLHttpRequest} */ element = this.element;
  if (!this._responseHeaders) {
    allHeaders = element.getAllResponseHeaders();
    this._responseHeaders = allHeaders.split('\n');
    n = this._responseHeaders.length;
    for (i = 0; i < n; i++) {
      hdr = org.apache.royale.utils.Language.string(this._responseHeaders[i]);
      c = hdr.indexOf(':');
      part1 = hdr.substring(0, c);
      part2 = hdr.substring(c + 2);
      this._responseHeaders[i] = new org.apache.royale.net.HTTPHeader(part1, part2);
    }
  }
  return this._responseHeaders;
};


org.apache.royale.net.HTTPService.prototype.get__responseURL = function() {
  return this._responseURL;
};


org.apache.royale.net.HTTPService.prototype.get__status = function() {
  return this._status;
};


org.apache.royale.net.HTTPService.prototype.get__statusText = function() {
  return org.apache.royale.utils.Language.as(this.element, XMLHttpRequest).statusText;
};


org.apache.royale.net.HTTPService.prototype.get__url = function() {
  return this._url;
};


org.apache.royale.net.HTTPService.prototype.set__url = function(value) {
  if (this._url != value) {
    this._url = value;
    this.dispatchEvent(new org.apache.royale.events.Event("urlChanged"));
  }
};


org.apache.royale.net.HTTPService.prototype.get__timeout = function() {
  return this._timeout;
};


org.apache.royale.net.HTTPService.prototype.set__timeout = function(value) {
  if (this._timeout != value) {
    this._timeout = value;
    this.dispatchEvent(new org.apache.royale.events.Event("timeoutChanged"));
  }
};


org.apache.royale.net.HTTPService.prototype.get__id = function() {
  return this._id;
};


org.apache.royale.net.HTTPService.prototype.set__id = function(value) {
  if (this._id != value) {
    this._id = value;
    this.dispatchEvent(new org.apache.royale.events.Event("idChanged"));
  }
};


org.apache.royale.net.HTTPService.prototype.set__strand = function(value) {
  this._strand = value;
  if (this._beads == null) {
    var foreachiter1_target = this.beads;
    for (var foreachiter1 in foreachiter1_target) 
    {
    var bead = foreachiter1_target[foreachiter1];
    
      this.addBead(bead);}
    
  }
  this.dispatchEvent(new org.apache.royale.events.Event("beadsAdded"));
};


org.apache.royale.net.HTTPService.prototype.set__withCredentials = function(value) {
  var /** @type {XMLHttpRequest} */ element = org.apache.royale.utils.Language.as(this.element, XMLHttpRequest);
  element.withCredentials = value;
};


org.apache.royale.net.HTTPService.prototype.get__data = function() {
  
  return this.element.responseText;
};


org.apache.royale.net.HTTPService.prototype.get__json = function() {
  org.apache.royale.debugging.assert(this.data, "data must exist before calling json getter!");
  if (!this._json)
    this._json = JSON.parse(this.data);
  return this._json;
};


Object.defineProperties(org.apache.royale.net.HTTPService.prototype, /** @lends {org.apache.royale.net.HTTPService.prototype} */ {
/**
  * @export
  * @type {string} */
contentType: {
get: org.apache.royale.net.HTTPService.prototype.get__contentType,
set: org.apache.royale.net.HTTPService.prototype.set__contentType},
/**
  * @export
  * @type {string} */
contentData: {
get: org.apache.royale.net.HTTPService.prototype.get__contentData,
set: org.apache.royale.net.HTTPService.prototype.set__contentData},
/**
  * @export
  * @type {Array} */
headers: {
get: org.apache.royale.net.HTTPService.prototype.get__headers,
set: org.apache.royale.net.HTTPService.prototype.set__headers},
/**
  * @export
  * @type {string} */
method: {
get: org.apache.royale.net.HTTPService.prototype.get__method,
set: org.apache.royale.net.HTTPService.prototype.set__method},
/**
  * @export
  * @type {Array} */
responseHeaders: {
get: org.apache.royale.net.HTTPService.prototype.get__responseHeaders},
/**
  * @export
  * @type {string} */
responseURL: {
get: org.apache.royale.net.HTTPService.prototype.get__responseURL},
/**
  * @export
  * @type {number} */
status: {
get: org.apache.royale.net.HTTPService.prototype.get__status},
/**
  * @export
  * @type {string} */
statusText: {
get: org.apache.royale.net.HTTPService.prototype.get__statusText},
/**
  * @export
  * @type {string} */
url: {
get: org.apache.royale.net.HTTPService.prototype.get__url,
set: org.apache.royale.net.HTTPService.prototype.set__url},
/**
  * @export
  * @type {number} */
timeout: {
get: org.apache.royale.net.HTTPService.prototype.get__timeout,
set: org.apache.royale.net.HTTPService.prototype.set__timeout},
/**
  * @export
  * @type {string} */
id: {
get: org.apache.royale.net.HTTPService.prototype.get__id,
set: org.apache.royale.net.HTTPService.prototype.set__id},
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.net.HTTPService.prototype.set__strand},
/**
  * @export
  * @type {boolean} */
withCredentials: {
set: org.apache.royale.net.HTTPService.prototype.set__withCredentials},
/**
  * @export
  * @type {string} */
data: {
get: org.apache.royale.net.HTTPService.prototype.get__data},
/**
  * @export
  * @type {Object} */
json: {
get: org.apache.royale.net.HTTPService.prototype.get__json}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.HTTPService.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HTTPService', qName: 'org.apache.royale.net.HTTPService', kind: 'class' }], interfaces: [org.apache.royale.core.IStrand, org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.HTTPService.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'beads': { type: 'Array'}
      };
    },
    accessors: function () {
      return {
        'contentType': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.HTTPService'},
        'contentData': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.HTTPService'},
        'headers': { type: 'Array', access: 'readwrite', declaredBy: 'org.apache.royale.net.HTTPService'},
        'method': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.HTTPService'},
        'responseHeaders': { type: 'Array', access: 'readonly', declaredBy: 'org.apache.royale.net.HTTPService'},
        'responseURL': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.net.HTTPService'},
        'status': { type: 'int', access: 'readonly', declaredBy: 'org.apache.royale.net.HTTPService'},
        'statusText': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.net.HTTPService'},
        'url': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.HTTPService'},
        'timeout': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.net.HTTPService'},
        'id': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.HTTPService'},
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.net.HTTPService'},
        'withCredentials': { type: 'Boolean', access: 'writeonly', declaredBy: 'org.apache.royale.net.HTTPService'},
        'data': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.net.HTTPService'},
        'json': { type: 'Object', access: 'readonly', declaredBy: 'org.apache.royale.net.HTTPService'}
      };
    },
    methods: function () {
      return {
        'HTTPService': { type: '', declaredBy: 'org.apache.royale.net.HTTPService'},
        'send': { type: 'void', declaredBy: 'org.apache.royale.net.HTTPService'}
      };
    },
    metadata: function () { return [  ]; }
  };
};