/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/URLBinaryLoader.as
 * org.apache.royale.net.URLBinaryLoader
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.URLBinaryLoader');

goog.require('org.apache.royale.events.DetailEvent');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.ProgressEvent');
goog.require('org.apache.royale.net.URLLoader');
goog.require('org.apache.royale.net.URLStream');
goog.require('org.apache.royale.utils.Endian');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.net.URLLoader}
 */
org.apache.royale.net.URLBinaryLoader = function() {
  
  this.endian = org.apache.royale.utils.Endian.BIG_ENDIAN;
  org.apache.royale.net.URLBinaryLoader.base(this, 'constructor');
  this.createStream();
};
goog.inherits(org.apache.royale.net.URLBinaryLoader, org.apache.royale.net.URLLoader);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.net.URLBinaryLoader', org.apache.royale.net.URLBinaryLoader);


/**
 * @export
 * @type {org.apache.royale.utils.BinaryData}
 */
org.apache.royale.net.URLBinaryLoader.prototype.data;


/**
 * @export
 * @type {string}
 */
org.apache.royale.net.URLBinaryLoader.prototype.endian;


/**
 * @protected
 * @type {org.apache.royale.net.URLStream}
 */
org.apache.royale.net.URLBinaryLoader.prototype.stream;


/**
 * @export
 * @type {number}
 */
org.apache.royale.net.URLBinaryLoader.prototype.bytesLoaded = 0;


/**
 * @export
 * @type {number}
 */
org.apache.royale.net.URLBinaryLoader.prototype.bytesTotal = 0;


/**
 * @protected
 */
org.apache.royale.net.URLBinaryLoader.prototype.createStream = function() {
  this.stream = new org.apache.royale.net.URLStream();
};


/**
 * @private
 * @param {org.apache.royale.net.URLStream} stream
 */
org.apache.royale.net.URLBinaryLoader.prototype.progressFunction = function(stream) {
  this.bytesLoaded = stream.bytesLoaded;
  this.bytesTotal = stream.bytesTotal;
  this.dispatchEvent(new org.apache.royale.events.ProgressEvent("progress", false, false, this.bytesLoaded, this.bytesTotal));
  if (this.onProgress)
    this.onProgress(this);
};


/**
 * @private
 * @param {org.apache.royale.net.URLStream} stream
 */
org.apache.royale.net.URLBinaryLoader.prototype.statusFunction = function(stream) {
  this.requestStatus = stream.requestStatus;
  this.dispatchEvent(new org.apache.royale.events.DetailEvent("httpStatus", false, false, "" + this.requestStatus));
  if (this.onStatus)
    this.onStatus(this);
};


/**
 * @private
 * @param {org.apache.royale.net.URLStream} stream
 */
org.apache.royale.net.URLBinaryLoader.prototype.errorFunction = function(stream) {
  this.dispatchEvent(new org.apache.royale.events.DetailEvent("communicationError", false, false, "" + this.requestStatus));
  if (this.onError)
    this.onError(this);
  this.cleanupCallbacks();
};


/**
 * @private
 * @param {org.apache.royale.net.URLStream} stream
 */
org.apache.royale.net.URLBinaryLoader.prototype.completeFunction = function(stream) {
  this.data = stream.response;
  this.dispatchEvent(new org.apache.royale.events.Event("complete"));
  if (this.onComplete)
    this.onComplete(this);
  this.cleanupCallbacks();
};


/**
 * @protected
 */
org.apache.royale.net.URLBinaryLoader.prototype.setupCallbacks = function() {
  this.stream.onProgress = org.apache.royale.utils.Language.closure(this.progressFunction, this, 'progressFunction');
  this.stream.onStatus = org.apache.royale.utils.Language.closure(this.statusFunction, this, 'statusFunction');
  this.stream.onError = org.apache.royale.utils.Language.closure(this.errorFunction, this, 'errorFunction');
  this.stream.onComplete = org.apache.royale.utils.Language.closure(this.completeFunction, this, 'completeFunction');
};


/**
 *  Makes the URL request.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.7.0
 * @export
 * @param {org.apache.royale.net.URLRequest} request
 */
org.apache.royale.net.URLBinaryLoader.prototype.load = function(request) {
  this.setupCallbacks();
  this.stream.load(request);
};


/**
 *  Cancels the URL request.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.7.0
 * @export
 */
org.apache.royale.net.URLBinaryLoader.prototype.close = function() {
  this.stream.close();
  this.cleanupCallbacks();
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.URLBinaryLoader.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'URLBinaryLoader', qName: 'org.apache.royale.net.URLBinaryLoader', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.URLBinaryLoader.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'data': { type: 'org.apache.royale.utils.BinaryData'},
        'endian': { type: 'String'},
        'bytesLoaded': { type: 'uint'},
        'bytesTotal': { type: 'uint'}
      };
    },
    accessors: function () {return {};},
    methods: function () {
      return {
        'URLBinaryLoader': { type: '', declaredBy: 'org.apache.royale.net.URLBinaryLoader'},
        'load': { type: 'void', declaredBy: 'org.apache.royale.net.URLBinaryLoader', parameters: function () { return [  { index: 1, type: 'org.apache.royale.net.URLRequest', optional: false } ]; }},
        'close': { type: 'void', declaredBy: 'org.apache.royale.net.URLBinaryLoader'}
      };
    }
  };
};