/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/URLUploadStream.as
 * org.apache.royale.net.URLUploadStream
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.URLUploadStream');

goog.require('org.apache.royale.events.ProgressEvent');
goog.require('org.apache.royale.net.URLStream');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.net.URLStream}
 */
org.apache.royale.net.URLUploadStream = function() {
  org.apache.royale.net.URLUploadStream.base(this, 'constructor');
};
goog.inherits(org.apache.royale.net.URLUploadStream, org.apache.royale.net.URLStream);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.net.URLUploadStream', org.apache.royale.net.URLUploadStream);


/**
 * @protected
 * @override
 */
org.apache.royale.net.URLUploadStream.prototype.send = function(requestData) {
  this.xhr.upload.onprogress = org.apache.royale.utils.Language.closure(this.xhr_uploadprogress, this, 'xhr_uploadprogress');
  this.xhr.send(requestData);
};


/**
 *  Upload is progressing (JS only).
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.7.0
 * @private
 * @param {Object} progress
 */
org.apache.royale.net.URLUploadStream.prototype.xhr_uploadprogress = function(progress) {
  var /** @type {org.apache.royale.events.ProgressEvent} */ progEv = new org.apache.royale.events.ProgressEvent("uploadprogress");
  progEv.current = this.bytesLoaded = Number(progress["loaded"]);
  progEv.total = this.bytesTotal = Number(progress["total"]);
  this.dispatchEvent(progEv);
  if (this.onUploadProgress)
    this.onUploadProgress(this);
};


/**
 *  Cleanup all callbacks.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.7.0
 * @protected
 * @override
 */
org.apache.royale.net.URLUploadStream.prototype.cleanupCallbacks = function() {
  org.apache.royale.net.URLUploadStream.superClass_.cleanupCallbacks.apply(this);
  this.onUploadProgress = null;
};


/**
 * @export
 * @type {Function}
 */
org.apache.royale.net.URLUploadStream.prototype.onUploadProgress;


/**
 *  Convenience function for upload progress event to allow chaining.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.7.0
 * @export
 * @param {Function} callback
 * @return {org.apache.royale.net.URLStream}
 */
org.apache.royale.net.URLUploadStream.prototype.uploadProgress = function(callback) {
  this.onUploadProgress = callback;
  return this;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.URLUploadStream.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'URLUploadStream', qName: 'org.apache.royale.net.URLUploadStream', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.URLUploadStream.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'onUploadProgress': { type: 'Function'}
      };
    },
    accessors: function () {return {};},
    methods: function () {
      return {
        'URLUploadStream': { type: '', declaredBy: 'org.apache.royale.net.URLUploadStream'},
        'uploadProgress': { type: 'org.apache.royale.net.URLStream', declaredBy: 'org.apache.royale.net.URLUploadStream', parameters: function () { return [  { index: 1, type: 'Function', optional: false } ]; }}
      };
    }
  };
};