/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/beads/CORSCredentialsBead.as
 * org.apache.royale.net.beads.CORSCredentialsBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.beads.CORSCredentialsBead');

goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 * @param {boolean=} withCredentials
 */
org.apache.royale.net.beads.CORSCredentialsBead = function(withCredentials) {
  withCredentials = typeof withCredentials !== 'undefined' ? withCredentials : false;
  this.withCredentials = withCredentials;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.net.beads.CORSCredentialsBead', org.apache.royale.net.beads.CORSCredentialsBead);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.net.beads.CORSCredentialsBead.prototype._strand;


/**
 *  Modify the HTTP request to pass credentials.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.8
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.net.beads.CORSCredentialsBead.prototype.preSendHandler = function(event) {
  org.apache.royale.utils.Language.as(event.target.element, XMLHttpRequest).withCredentials = this.withCredentials;
};


/**
 *  Clean up event listeners.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.8
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.net.beads.CORSCredentialsBead.prototype.postSendHandler = function(event) {
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher, true).removeEventListener("preSend", org.apache.royale.utils.Language.closure(this.preSendHandler, this, 'preSendHandler'));
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher, true).removeEventListener("postSend", org.apache.royale.utils.Language.closure(this.preSendHandler, this, 'preSendHandler'));
};


/**
 * @private
 * @type {boolean}
 */
org.apache.royale.net.beads.CORSCredentialsBead.prototype._withCredentials = false;


org.apache.royale.net.beads.CORSCredentialsBead.prototype.set__strand = function(value) {
  this._strand = value;
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher, true).addEventListener("preSend", org.apache.royale.utils.Language.closure(this.preSendHandler, this, 'preSendHandler'));
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher, true).addEventListener("postSend", org.apache.royale.utils.Language.closure(this.postSendHandler, this, 'postSendHandler'));
};


org.apache.royale.net.beads.CORSCredentialsBead.prototype.get__withCredentials = function() {
  return this._withCredentials;
};


org.apache.royale.net.beads.CORSCredentialsBead.prototype.set__withCredentials = function(value) {
  this._withCredentials = value;
};


Object.defineProperties(org.apache.royale.net.beads.CORSCredentialsBead.prototype, /** @lends {org.apache.royale.net.beads.CORSCredentialsBead.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.net.beads.CORSCredentialsBead.prototype.set__strand},
/**
  * @export
  * @type {boolean} */
withCredentials: {
get: org.apache.royale.net.beads.CORSCredentialsBead.prototype.get__withCredentials,
set: org.apache.royale.net.beads.CORSCredentialsBead.prototype.set__withCredentials}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.beads.CORSCredentialsBead.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CORSCredentialsBead', qName: 'org.apache.royale.net.beads.CORSCredentialsBead', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.beads.CORSCredentialsBead.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.net.beads.CORSCredentialsBead'},
        'withCredentials': { type: 'Boolean', access: 'readwrite', declaredBy: 'org.apache.royale.net.beads.CORSCredentialsBead'}
      };
    },
    methods: function () {
      return {
        'CORSCredentialsBead': { type: '', declaredBy: 'org.apache.royale.net.beads.CORSCredentialsBead', parameters: function () { return [  { index: 1, type: 'Boolean', optional: true } ]; }}
      };
    }
  };
};