/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/remoting/amf/AMFNetConnection.as
 * org.apache.royale.net.remoting.amf.AMFNetConnection
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.remoting.amf.AMFNetConnection');

goog.require('org.apache.royale.net.remoting.amf.AMFBinaryData');
goog.require('org.apache.royale.net.remoting.messages.ActionMessage');
goog.require('org.apache.royale.net.remoting.messages.ErrorMessage');
goog.require('org.apache.royale.net.remoting.messages.MessageBody');
goog.require('org.apache.royale.net.remoting.messages.MessageHeader');
goog.require('org.apache.royale.utils.Language');



/**
 *  Constructor
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @constructor
 */
org.apache.royale.net.remoting.amf.AMFNetConnection = function() {
  ;
  
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.net.remoting.amf.AMFNetConnection', org.apache.royale.net.remoting.amf.AMFNetConnection);


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.url;


/**
 *  Connect to a server.  Pass in an http URL as the commmand for
 *  connection to AMF server.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @export
 * @param {string} command
 * @param {...} params
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.connect = function(command, params) {
  params = Array.prototype.slice.call(arguments, 1);
  this.url = command;
  
};


/**
 * @private
 * @type {XMLHttpRequest}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.xhr;


/**
 * @private
 * @type {org.apache.royale.net.Responder}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.responder;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.args;


/**
 *  Call a server function.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @export
 * @param {string} command
 * @param {org.apache.royale.net.Responder} responder
 * @param {...} params
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.call = function(command, responder, params) {
  params = Array.prototype.slice.call(arguments, 2);
  
  this.responder = responder;
  this.args = params;
  if (!this.xhr) {
    this.xhr = new XMLHttpRequest();
    this.xhr.onreadystatechange = org.apache.royale.utils.Language.closure(this.onReadyStateChange, this, 'onReadyStateChange');
  }
  this.xhr.open("POST", this.url, true);
};


/**
 * @private
 * @type {number}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.sequence = 0;


/**
 * @royaleignorecoercion Array
 * @private
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.onReadyStateChange = function() {
  var /** @type {number} */ readyState = this.xhr.readyState;
  if (readyState === 1) {
    this.xhr.setRequestHeader("Content-Type", "application/x-amf; charset=UTF-8");
    this.xhr.responseType = "arraybuffer";
    var /** @type {org.apache.royale.net.remoting.messages.ActionMessage} */ actionMessage = new org.apache.royale.net.remoting.messages.ActionMessage();
    var /** @type {org.apache.royale.net.remoting.messages.MessageBody} */ messageBody = new org.apache.royale.net.remoting.messages.MessageBody();
    this.sequence++;
    messageBody.responseURI = "/" + this.sequence.toString();
    messageBody.data = this.args;
    actionMessage.bodies = [messageBody];
    var /** @type {org.apache.royale.net.remoting.amf.AMFBinaryData} */ binaryData = new org.apache.royale.net.remoting.amf.AMFBinaryData();
    this.writeMessage(binaryData, actionMessage);
    this.xhr.send(new Uint8Array(binaryData.data));
  } else if (readyState === 4) {
    try {
      if (this.xhr.status >= 200 && this.xhr.status <= 300 && this.xhr.responseType == "arraybuffer" && this.xhr.getResponseHeader("Content-type").indexOf("application/x-amf") > -1) {
        var /** @type {org.apache.royale.net.remoting.messages.ActionMessage} */ message;
        var /** @type {org.apache.royale.net.remoting.messages.MessageBody} */ body;
        var /** @type {org.apache.royale.net.remoting.amf.AMFBinaryData} */ deserializer = new org.apache.royale.net.remoting.amf.AMFBinaryData(new Uint8Array(this.xhr.response));
        try {
          message = org.apache.royale.utils.Language.as(this.readMessage(deserializer), org.apache.royale.net.remoting.messages.ActionMessage);
        } catch (e) {
          this.responder.onFailure({code:-1001, message:"Failed decoding the response.", detail:null, data:null});
          return;
        }
        for (var /** @type {number} */ i in message.bodies) {
          body = message.bodies[i];
          if (!org.apache.royale.utils.Language.is(body.data, org.apache.royale.net.remoting.messages.ErrorMessage))
            this.responder.onSuccess(body.data);
          else
            this.responder.onFailure(body.data);
        }
      } else if (this.xhr.status == 0 || this.xhr.responseType == "text") {
        this.responder.onFailure({code:-1004, message:"Invalid response type.", detail:"Invalid XMLHttpRequest response status or type.", data:null});
      } else {
        this.responder.onFailure({code:-1005, message:"Invalid response.", detail:"", data:null});
      }
    } catch (e) {
      this.responder.onFailure({code:-1006, message:"Unknown error.", detail:e.message, data:null});
    }
  }
};


/**
 * @private
 * @param {org.apache.royale.net.remoting.amf.AMFBinaryData} writer
 * @param {org.apache.royale.net.remoting.messages.ActionMessage} message
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.writeMessage = function(writer, message) {
  try {
    writer.writeShort(message.version);
    writer.writeShort(message.headers.length);
    for (var /** @type {org.apache.royale.net.remoting.messages.MessageHeader} */ header in message.headers) {
      this.writeHeader(writer, message.headers[header]);
    }
    writer.writeShort(message.bodies.length);
    for (var /** @type {org.apache.royale.net.remoting.messages.MessageBody} */ body in message.bodies) {
      this.writeBody(writer, message.bodies[body]);
    }
  } catch (error) {
    console.log(error);
  }
};


/**
 * @private
 * @param {org.apache.royale.net.remoting.amf.AMFBinaryData} writer
 * @param {org.apache.royale.net.remoting.messages.MessageHeader} header
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.writeHeader = function(writer, header) {
  writer.writeUTF(header.name);
  writer.writeBoolean(header.mustUnderstand);
  writer.writeInt(org.apache.royale.net.remoting.amf.AMFBinaryData.UNKNOWN_CONTENT_LENGTH);
  writer.reset();
  writer.write(org.apache.royale.net.remoting.amf.AMFBinaryData.AMF0_BOOLEAN);
  writer.writeBoolean(true);
};


/**
 * @private
 * @param {org.apache.royale.net.remoting.amf.AMFBinaryData} writer
 * @param {org.apache.royale.net.remoting.messages.MessageBody} body
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.writeBody = function(writer, body) {
  if (body.targetURI == null) {
    writer.writeUTF(org.apache.royale.net.remoting.amf.AMFBinaryData.NULL_STRING);
  } else {
    writer.writeUTF(body.targetURI);
  }
  if (body.responseURI == null) {
    writer.writeUTF(org.apache.royale.net.remoting.amf.AMFBinaryData.NULL_STRING);
  } else {
    writer.writeUTF(body.responseURI);
  }
  writer.writeInt(org.apache.royale.net.remoting.amf.AMFBinaryData.UNKNOWN_CONTENT_LENGTH);
  writer.reset();
  writer.write(org.apache.royale.net.remoting.amf.AMFBinaryData.AMF0_AMF3);
  writer.writeObject(body.data);
};


/**
 * @private
 * @param {org.apache.royale.net.remoting.amf.AMFBinaryData} reader
 * @return {org.apache.royale.net.remoting.messages.ActionMessage}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.readMessage = function(reader) {
  var /** @type {org.apache.royale.net.remoting.messages.ActionMessage} */ message = new org.apache.royale.net.remoting.messages.ActionMessage();
  message.version = reader.readUnsignedShort();
  var /** @type {number} */ headerCount = reader.readUnsignedShort();
  for (var /** @type {number} */ i = 0; i < headerCount; i++) {
    message.headers.push(this.readHeader(reader));
  }
  var /** @type {number} */ bodyCount = reader.readUnsignedShort();
  for (i = 0; i < bodyCount; i++) {
    message.bodies.push(this.readBody(reader));
  }
  return message;
};


/**
 * @private
 * @param {org.apache.royale.net.remoting.amf.AMFBinaryData} reader
 * @return {org.apache.royale.net.remoting.messages.MessageHeader}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.readHeader = function(reader) {
  var /** @type {org.apache.royale.net.remoting.messages.MessageHeader} */ header = new org.apache.royale.net.remoting.messages.MessageHeader();
  header.name = reader.readUTF();
  header.mustUnderstand = reader.readBoolean();
  reader.pos += 4;
  reader.reset();
  var /** @type {number} */ type = reader.read();
  if (type != 2) {
    throw "Only string header data supported.";
  }
  header.data = reader.readUTF();
  return header;
};


/**
 * @private
 * @param {org.apache.royale.net.remoting.amf.AMFBinaryData} reader
 * @return {org.apache.royale.net.remoting.messages.MessageBody}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.readBody = function(reader) {
  var /** @type {org.apache.royale.net.remoting.messages.MessageBody} */ body = new org.apache.royale.net.remoting.messages.MessageBody();
  body.targetURI = reader.readUTF();
  body.responseURI = reader.readUTF();
  reader.pos += 4;
  reader.reset();
  body.data = reader.readObject();
  return body;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AMFNetConnection', qName: 'org.apache.royale.net.remoting.amf.AMFNetConnection', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.remoting.amf.AMFNetConnection.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {return {};},
    methods: function () {
      return {
        'AMFNetConnection': { type: '', declaredBy: 'org.apache.royale.net.remoting.amf.AMFNetConnection'},
        'connect': { type: 'void', declaredBy: 'org.apache.royale.net.remoting.amf.AMFNetConnection', parameters: function () { return [  { index: 1, type: 'String', optional: false },{ index: 2, type: 'Array', optional: false } ]; }},
        'call': { type: 'void', declaredBy: 'org.apache.royale.net.remoting.amf.AMFNetConnection', parameters: function () { return [  { index: 1, type: 'String', optional: false },{ index: 2, type: 'org.apache.royale.net.Responder', optional: false },{ index: 3, type: 'Array', optional: false } ]; }}
      };
    }
  };
};