/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/remoting/messages/AbstractMessage.as
 * org.apache.royale.net.remoting.messages.AbstractMessage
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.remoting.messages.AbstractMessage');

goog.require('org.apache.royale.utils.ObjectUtil');
goog.require('org.apache.royale.utils.UIDUtil');
goog.require('org.apache.royale.net.remoting.messages.IMessage');



/**
 *  Constructs an instance of an AbstractMessage with an empty body and header.
 *  This message type should not be instantiated or used directly.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @constructor
 * @implements {org.apache.royale.net.remoting.messages.IMessage}
 */
org.apache.royale.net.remoting.messages.AbstractMessage = function() {
  
  this._body = {};
  ;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.net.remoting.messages.AbstractMessage', org.apache.royale.net.remoting.messages.AbstractMessage);


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.DESTINATION_CLIENT_ID_HEADER = "DSDstClientId";


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.ENDPOINT_HEADER = "DSEndpoint";


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.FLEX_CLIENT_ID_HEADER = "DSId";


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.PRIORITY_HEADER = "DSPriority";


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.REMOTE_CREDENTIALS_HEADER = "DSRemoteCredentials";


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.REMOTE_CREDENTIALS_CHARSET_HEADER = "DSRemoteCredentialsCharset";


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.REQUEST_TIMEOUT_HEADER = "DSRequestTimeout";


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.STATUS_CODE_HEADER = "DSStatusCode";


/**
 * @private
 * @type {Object}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype._body;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype._clientId;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype._destination = "";


/**
 * @private
 * @type {Object}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype._headers;


/**
 * @private
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype._messageId;


/**
 * @private
 * @type {number}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype._timestamp = 0;


/**
 * @private
 * @type {number}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype._timeToLive = 0;


/**
 *  Returns a string representation of the message.
 *
 *  @asreturn String representation of the message.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @export
 * @return {string}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype.toString = function() {
  return org.apache.royale.utils.ObjectUtil._toString(this);
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__body = function() {
  return this._body;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__body = function(value) {
  this._body = value;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__clientId = function() {
  return this._clientId;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__clientId = function(value) {
  this._clientId = value;
  
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__destination = function() {
  return this._destination;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__destination = function(value) {
  this._destination = value;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__headers = function() {
  if (this._headers == null)
    this._headers = {};
  return this._headers;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__headers = function(value) {
  this._headers = value;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__messageId = function() {
  if (this._messageId == null)
    this._messageId = org.apache.royale.utils.UIDUtil.createUID();
  return this._messageId;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__messageId = function(value) {
  this._messageId = value;
  
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__timestamp = function() {
  return this._timestamp;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__timestamp = function(value) {
  this._timestamp = value;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__timeToLive = function() {
  return this._timeToLive;
};


org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__timeToLive = function(value) {
  this._timeToLive = value;
};


Object.defineProperties(org.apache.royale.net.remoting.messages.AbstractMessage.prototype, /** @lends {org.apache.royale.net.remoting.messages.AbstractMessage.prototype} */ {
/**
  * @export
  * @type {Object} */
body: {
get: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__body,
set: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__body},
/**
  * @export
  * @type {string} */
clientId: {
get: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__clientId,
set: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__clientId},
/**
  * @export
  * @type {string} */
destination: {
get: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__destination,
set: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__destination},
/**
  * @export
  * @type {Object} */
headers: {
get: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__headers,
set: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__headers},
/**
  * @export
  * @type {string} */
messageId: {
get: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__messageId,
set: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__messageId},
/**
  * @export
  * @type {number} */
timestamp: {
get: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__timestamp,
set: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__timestamp},
/**
  * @export
  * @type {number} */
timeToLive: {
get: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.get__timeToLive,
set: org.apache.royale.net.remoting.messages.AbstractMessage.prototype.set__timeToLive}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AbstractMessage', qName: 'org.apache.royale.net.remoting.messages.AbstractMessage', kind: 'class' }], interfaces: [org.apache.royale.net.remoting.messages.IMessage] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.remoting.messages.AbstractMessage.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'body': { type: 'Object', access: 'readwrite', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'},
        'clientId': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'},
        'destination': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'},
        'headers': { type: 'Object', access: 'readwrite', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'},
        'messageId': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'},
        'timestamp': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'},
        'timeToLive': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'}
      };
    },
    methods: function () {
      return {
        'AbstractMessage': { type: '', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'},
        'toString': { type: 'String', declaredBy: 'org.apache.royale.net.remoting.messages.AbstractMessage'}
      };
    }
  };
};