/**
 * Generated by Apache Royale Compiler from org/apache/royale/net/remoting/messages/AsyncMessage.as
 * org.apache.royale.net.remoting.messages.AsyncMessage
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.net.remoting.messages.AsyncMessage');

goog.require('org.apache.royale.net.remoting.messages.AbstractMessage');



/**
 *  Constructs an instance of an AsyncMessage with an empty body and header.
 *  In addition to this default behavior, the body and the headers for the
 *  message may also be passed to the constructor as a convenience.
 *  An example of this invocation approach for the body is:
 *  <code>var msg:AsyncMessage = new AsyncMessage("Body text");</code>
 *  An example that provides both the body and headers is:
 *  <code>var msg:AsyncMessage = new AsyncMessage("Body text", {"customerHeader":"customValue"});</code>
 * 
 *  @asparam body The optional body to assign to the message.
 * 
 *  @asparam headers The optional headers to assign to the message.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @constructor
 * @extends {org.apache.royale.net.remoting.messages.AbstractMessage}
 * @param {Object=} body
 * @param {Object=} headers
 */
org.apache.royale.net.remoting.messages.AsyncMessage = function(body, headers) {
  body = typeof body !== 'undefined' ? body : null;
  headers = typeof headers !== 'undefined' ? headers : null;
  org.apache.royale.net.remoting.messages.AsyncMessage.base(this, 'constructor');
  if (body != null)
    this.body = body;
  if (headers != null)
    this.headers = headers;
};
goog.inherits(org.apache.royale.net.remoting.messages.AsyncMessage, org.apache.royale.net.remoting.messages.AbstractMessage);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.net.remoting.messages.AsyncMessage', org.apache.royale.net.remoting.messages.AsyncMessage);


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.royale.net.remoting.messages.AsyncMessage.SUBTOPIC_HEADER = "DSSubtopic";


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.net.remoting.messages.AsyncMessage.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AsyncMessage', qName: 'org.apache.royale.net.remoting.messages.AsyncMessage', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.net.remoting.messages.AsyncMessage.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {return {};},
    methods: function () {
      return {
        'AsyncMessage': { type: '', declaredBy: 'org.apache.royale.net.remoting.messages.AsyncMessage', parameters: function () { return [  { index: 1, type: 'Object', optional: true },{ index: 2, type: 'Object', optional: true } ]; }}
      };
    },
    metadata: function () { return [  ]; }
  };
};